Unit taig4c_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, AIG4C_p;

function taig4c: String;

implementation

function taig4c: String;
var
M,N,I,J,JI,JJ,II,K,IERR :Integer;
B :Array [0..15] of Complex;
C :Array [0..15] of Complex;
Z :Array [0..3] of Complex;
NLEAD :Array [0..3] of Integer;
const
A :Array [0..15] of Complex = ( ( re:7.9; im: 0.0 ),( re:8.5; im: 0.0 ),( 
re:4.3; im: 0.0 ),( re:3.2; im: 0.0 ),( re:5.6; 
im: 0.0 ),( re:-4.8; im: 0.0 ),( re:4.2; im: 0.0 )
,( re:-1.4; im: 0.0 ),( re:5.7; im: 0.0 ),( 
re:0.8; im: 0.0 ),( re:-3.2; im: 0.0 ),( re:-8.9; 
im: 0.0 ),( re:-7.2; im: 0.0 ),( re:3.5; im: 0.0 )
,( re:9.3; im: 0.0 ),( re:3.3; im:  0.0 ) );
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
Result := '';  {   }
M := 4;
N := M;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    B[(I-1)+(J-1)*4] := A[(I-1)+(J-1)*4];
_1:
   end;
_2:
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   A=' + #$0D#$0A]);
for I:=1 to M do
 begin
  for J:= 1 to N do
   begin
    Result := Result + Format(' %20.16f  %20.16f  ',[A[(I-1)+(J-1)*4].re,A[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
AIG4C(A,M,N,NLEAD,Z,IERR);
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   NLEAD=' + #$0D#$0A]);
for JI:=1 to N do
 begin
  Result := Result + Format('%3d  ',[NLEAD[JI-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   A=' + #$0D#$0A]);
for II:=1 to M do
 begin
  for JJ:=1 to N do
   begin
    Result := Result + Format(' %20.16f  %20.16f  ',[A[(II-1)+(JJ-1)*4].re,A[(II-1)+(JJ-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   IERR=']);
Result := Result + Format('%3d ',[IERR]) + #$0D#$0A;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    C[(I-1)+(J-1)*4] := Cmplx(0.0,0.0);
    for K:=1 to N do
     begin
      C[(I-1)+(J-1)*4] := AddC(C[(I-1)+(J-1)*4],MulC(B[(I-1)+(K-1)*4],A[(K-1)+(J-1)*4]));
_3:
     end;
_4:
   end;
_5:
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   A*INVERSE(A)=' + #$0D#$0A]);
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    Result := Result + Format(' %20.16f  %20.16f  ',[C[(I-1)+(J-1)*4].re,C[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    C[(I-1)+(J-1)*4] := Cmplx(0.0,0.0);
    for K:=1 to N do
     begin
      C[(I-1)+(J-1)*4] := AddC(C[(I-1)+(J-1)*4],MulC(A[(I-1)+(K-1)*4],B[(K-1)+(J-1)*4]));
_6:
     end;
_7:
   end;
_8:
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   INVERSE(A)*A=' + #$0D#$0A]);
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    Result := Result + Format(' %20.16f  %20.16f  ',[C[(I-1)+(J-1)*4].re,C[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
UtRes('taig4c',Result);  {     taig4c.res }
exit;
end;

end.
